%
% Example 3
% Hopper
%
% Frank Peuker, 2012, Locomorph summer school
%

%
% Additional code units A,B and C (w.r.t. Example 2)
%

clear all

% 1 Integrator parameters
dt=1e-4;
tend=10;
t=0;
i=1;

% 2 Output parameters
dtsample=1e-2;
N=ceil(tend/dtsample);
di=ceil(dtsample/dt);
ts=zeros(N,20);

% 3 Parameters
m=80; 
L0=1;
k=20000;
g=9.81;

% 4 Initial values
y=1.2;
v=0;

% A Hybrid system variables
flight_fp=y-L0;            
fp=flight_fp;
yg=0;                

% 5 Just declaration
a=0; 
F=0;
flight=true;        

% ---------------------------------------------------- Time-looping -------
while t<tend       
    % B Event detector (to switch states)
    if flight_fp < 0
        flight = false;
        fp = 0;
    else
        flight = true;
        fp = flight_fp;
    end
    
    % 6 Assemble force
    F = -m*g;        
    if not(flight)
        F = F + k*(L0-y);  
    end
    
    % 7 2nd law newton
    a = F/m;
    
    % 8 Output
    if mod(i,di)==0
        is=i/di;
        ts(is,1:7)=[t y v a F flight fp];
    end
    
    % 9 Euler
    v = v + dt * a;
    y = y + dt * v;
    
    % C Update variables
    flight_fp=y-L0;
    
    % 10 Advance in time
    t=t+dt;
    i=i+1;
end
