%
% Example 2
% Vertical Oscillator
%
% Frank Peuker, 2012, Locomorph summer school
%

clear all

% 1 Integrator parameters
dt=1e-4;
tend=10;
t=0;
i=1;

% 2 Output parameters
dtsample=1e-2;
N=ceil(tend/dtsample);
di=ceil(dtsample/dt);
ts=zeros(N,10);

% 3 Parameters
m=80; 
k=1000;
g=9.81;

% 4 Initial values
L=1;
v=0;

% 5 Just declaration
a=0; 
F=0;

% ---------------------------------------------------- Time-looping -------
while t<tend    
    % 6 Assemble force
    F = -k*L;      % Spring force
    F = F + -m*g;  % Gravitational force
    
    % 7 2nd law newton
    a = F/m;
    
    % 8 Output
    if mod(i,di)==0
        is=i/di;
        ts(is,1:6)=[t L v a F m/2*v^2 + k/2*L^2 + m*g*L];
    end
    
    % 9 Euler
    v = v + dt * a;
    L = L + dt * v;
    
    % 10 Advance in time
    t=t+dt;
    i=i+1;
end
